proc topo-half-dumbbell {num_links} {
    global ns n s r bw queue

    set n(0) [$ns node]
    set n(1) [$ns node]
    set s(0) [$ns node]
    for {set i 0} {$i < $num_links} {incr i} {
	set r($i) [$ns node]
    }

    $ns duplex-link $n(0) $n(1) [expr $bw*1000] 10ms DropTail
    if [info exists queue] {
	$ns queue-limit $n(0) $n(1) $queue
	$ns queue-limit $n(1) $n(0) $queue
    }
    $ns duplex-link $s(0) $n(0) 100Mb  10ms DropTail
    for {set i 0} {$i < $num_links} {incr i} {
	$ns duplex-link $n(1) $r($i) 100Mb  10ms DropTail
    }
}

proc topo-dumbbell {num_links} {
    global ns n s r bw queue

    set n(0) [$ns node]
    set n(1) [$ns node]
    for {set i 0} {$i < $num_links} {incr i} {
	set s($i) [$ns node]
	set r($i) [$ns node]
    }

    #$ns duplex-link $n(0) $n(1) [expr $bw*1000] 10ms RED
    $ns duplex-link $n(0) $n(1) [expr $bw*1000] 10ms DropTail
    if [info exists queue] {
	$ns queue-limit $n(0) $n(1) $queue
	$ns queue-limit $n(1) $n(0) $queue
    }
    for {set i 0} {$i < $num_links} {incr i} {
	$ns duplex-link $s($i) $n(0) 100Mb  10ms DropTail
	$ns duplex-link $n(1) $r($i) 100Mb  10ms DropTail
    }
}

proc topo-dumbbell-recv {num_links} {
    global ns n s r bw queue

    set n(0) [$ns node]
    set n(1) [$ns node]
    for {set i 0} {$i < $num_links} {incr i} {
	set s($i) [$ns node]
	set r($i) [$ns node]
    }

    $ns duplex-link $n(0) $n(1) 1000Mb 10ms DropTail
    if [info exists queue] {
	$ns queue-limit $n(0) $n(1) $queue
	$ns queue-limit $n(1) $n(0) $queue
    }
    for {set i 0} {$i < $num_links} {incr i} {
	$ns duplex-link $s($i) $n(0) 100Mb 10ms DropTail
	$ns duplex-link $n(1) $r($i) [expr $bw*1000] 10ms DropTail
    }
}

proc topo-bintree {depth} {
    global ns n s r bw queue

    set s(0) [$ns node]
    set n(0) [$ns node]
    set n(1) [$ns node]
    $ns duplex-link $s(0) $n(0) 100Mb 10ms DropTail
    $ns duplex-link $n(0) $n(1) [expr $bw*1000] 10ms DropTail
    if [info exists queue] {
	$ns queue-limit $n(0) $n(1) $queue
	$ns queue-limit $n(1) $n(0) $queue
    }

    set nr 2
    for {set j 1} {$j <= $depth} {incr j} {
	for {set i 0} {$i < [expr pow(2,$j)]} {incr i} {
	    set n($nr) [$ns node]
	    set parent [expr int($nr / 2)]
	    $ns duplex-link $n($nr) $n($parent) [expr $bw*1000] 10ms DropTail
	    $ns queue-limit $n($nr) $n($parent) $queue
	    $ns queue-limit $n($parent) $n($nr) $queue
	    #puts stderr "$nr to $parent"
	    incr nr
	}
    }
    
    for {set i 0} {$i < [expr pow(2,$depth)]} {incr i} {
	set r($i) [$ns node]
	$ns duplex-link $n([expr int(pow(2,$depth) + $i)]) $r($i) 100Mb 10ms DropTail
    }

}

proc topo-line {num_recvs} {
#
#           r0  r1   rn-1
#          /   /    /
# s0--n0--n1--...--nn--rn
#
#
    global ns n s r bw queue

    set s(0) [$ns node]
    for {set i 0} {$i < $num_recvs} {incr i} {
	set n($i) [$ns node]
	set r($i) [$ns node]
    }

    $ns duplex-link $s(0) $n(0) 100Mb 10ms DropTail
    for {set i 1} {$i < $num_recvs} {incr i} {
	$ns duplex-link $n([expr $i-1]) $n($i) [expr $bw*1000] 10ms DropTail
	if [info exists queue] {
	    $ns queue-limit $n([expr $i-1]) $n($i) $queue
	    $ns queue-limit $n($i) $n([expr $i-1]) $queue
	}
	$ns duplex-link $n($i) $r([expr $i-1]) 100Mb 10ms DropTail
    }
    $ns duplex-link $n([expr $num_recvs-1]) $r([expr $num_recvs-1]) 100Mb 10ms DropTail
}
